package bmsi.tui;
import java.awt.*;
import java.awt.event.*;
import java.awt.peer.*;
import java.io.IOException;

class TUIButton extends TUIComponent implements ButtonPeer {
  TUIButton(Button but,TUIKit toolkit) { super(but,toolkit); }
  protected void create(TUIContainer parent) {
    winID = toolkit.createRemotePeer(parent,NEWBUTTON,this);
  }
  public Dimension getMinimumSize() {
    Button but = (Button)target;
    return toolkit.scale(new Dimension(but.getLabel().length(),1));
  }
  protected void initialize() {
    Button but = (Button)target;
    String text = but.getLabel();
    if (text != null)
      setLabel(text);
    super.initialize();
  }
  public void setLabel(String s) { toolkit.writeCmd(this,SETTEXT,s); }
  public void remoteMethod(int cmd) throws IOException {
    if (cmd == MENUPICK) {
      Button but = (Button)target;
      toolkit.theQueue.postEvent(
	new ActionEvent(but,ActionEvent.ACTION_PERFORMED,but.getActionCommand())
      );
      return;
    }
    super.remoteMethod(cmd);
  }
}
