package bmsi.tui;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ItemEvent;
import java.awt.peer.*;
import java.io.IOException;

class TUICheckboxMenuItem extends TUIMenuItem implements CheckboxMenuItemPeer {
  TUICheckboxMenuItem(CheckboxMenuItem m,TUIKit toolkit) { super(m,toolkit); }
  protected void initialize() {
    CheckboxMenuItem m = (CheckboxMenuItem)target;
    if (m.getState())
      setState(true);
    super.initialize();
  }
  protected void create(TUIMenuComponent parent) {
    winID = toolkit.createRemotePeer(parent,NEWCHECKMENUITEM,this);
  }
  public void setState(boolean t) {
    toolkit.writeCmd(this,SETSTATE,t ? 1 : 0);
  }
  public void remoteMethod(int cmd) throws IOException {
    CheckboxMenuItem item = (CheckboxMenuItem)target;
    /*JDK1.0: item.postEvent(new Event(target,Event.ACTION_EVENT,
	item.getLabel())); */
    boolean t = !item.getState();
    item.setState(t);
    String label = item.getActionCommand();
    toolkit.theQueue.postEvent(
      new ItemEvent(item,ItemEvent.ITEM_STATE_CHANGED,label,
	t ? ItemEvent.SELECTED : ItemEvent.DESELECTED)
    );
    toolkit.theQueue.postEvent(
      new ActionEvent(item,ActionEvent.ACTION_PERFORMED,label)
    );
  }
}
