package bmsi.tui;

import java.awt.*;
import java.awt.peer.*;

class TUIDialog extends TUIFramedWindow implements DialogPeer {
  TUIDialog(Dialog d,TUIKit toolkit) { super(d,toolkit); }
  protected void initialize() {
    Dialog dlg = (Dialog)target;
    String title = dlg.getTitle();
    if (title != null)
      setTitle(title);
    if (!dlg.isResizable())
      setResizable(false);
    super.initialize();
  }
  protected void create(TUIContainer parent) {
    winID = toolkit.createRemotePeer(parent,NEWDIALOG,this);
  }

  private boolean visible = false;

  public synchronized void setVisible(boolean vis) {
    if (vis == visible) return;
    super.setVisible(vis);
    visible = vis;
    Dialog dlg = (Dialog)target;
    if (!vis)
      notify();		// notify thread waiting for HIDE
    else if (dlg.isModal())
      try {
	while (dlg.isVisible())
	  wait();
      }
      catch (InterruptedException e) {
	throw new AWTError("Interrupted waiting for Dialog close");
      }
  }
}
