package bmsi.tui;

import java.awt.*;
import java.awt.peer.*;

/** TUI Frames and Dialogs provide their own frames. */
class TUIFramedWindow extends TUIWindow {
  private Insets insets;
  TUIFramedWindow(Window w,TUIKit toolkit) {
    super(w,toolkit);
  }
  public void setTitle(String s) { toolkit.writeCmd(this,SETTITLE,s); }
  public void setResizable(boolean flg) {
    toolkit.writeCmd(this,SETRESIZABLE,flg ? 1 : 0);
  }
  // Our TUI system uses a 1 char frame on all sides (no shadowing).
  public Insets getInsets() {
    if (insets == null)
      insets = toolkit.getInsets(this);
    return insets;
  }
}
