/* $Log$
 */
package bmsi.tui;
import java.awt.image.ColorModel;
import java.awt.peer.*;
import java.awt.*;
import java.io.IOException;
import java.net.Socket;

public class TUIKit extends RemoteToolkit {
  ColorModelPeer colorModel = new TUIColorModel();

  public TUIKit() throws IOException { }

  public TUIKit(Socket sock) throws IOException { super(sock); }

  protected ButtonPeer createButton(Button b) { return new TUIButton(b,this); }
  protected TextFieldPeer createTextField(TextField t) {
    return new TUITextField(t,this);
  }
  protected LabelPeer createLabel(Label lbl) { return new TUILabel(lbl,this); }
  protected ListPeer createList(List lst) { return new TUIList(lst,this); }
  protected TextAreaPeer createTextArea(TextArea t) {
    return new TUITextArea(t,this);
  }
  public FontMetrics getFontMetrics(Font f) {
    return new TUIFontMetrics(f,scale(new Dimension(1,1)));
  }
  public ColorModel getColorModel() { return colorModel; }

  // how to create various peer objects  -

  protected CheckboxPeer createCheckbox(Checkbox cb) {
    return new TUICheckbox(cb,this);
  }
  protected ScrollbarPeer createScrollbar(Scrollbar s) {
    return new TUIScrollbar(s,this);
  }
  protected ChoicePeer createChoice(Choice c) { return new TUIChoice(c,this); }
  protected FramePeer createFrame(Frame f) { return new TUIFrame(f,this); }
  protected CanvasPeer createCanvas(Canvas c) { return new TUICanvas(c,this); }
  protected PanelPeer createPanel(Panel p) { return new TUIPanel(p,this); }
  protected WindowPeer createWindow(Window w) { return new TUIWindow(w,this); }
  protected DialogPeer createDialog(Dialog dlg) {
    return new TUIDialog(dlg,this);
  }
  protected MenuBarPeer createMenuBar(MenuBar mnu) {
    return new TUIMenuBar(mnu,this);
  }
  protected MenuPeer createMenu(Menu mnu) { return new TUIMenu(mnu,this); }
  protected MenuItemPeer createMenuItem(MenuItem mi) {
    return new TUIMenuItem(mi,this);
  }
  protected FileDialogPeer createFileDialog(FileDialog dlg) {
    return new TUIFileDialog(dlg);
  }
  protected CheckboxMenuItemPeer createCheckboxMenuItem(CheckboxMenuItem mi) {
    // work around AWT bug
    MenuComponentPeer p = mi.getPeer();
    if (p != null)
      return (CheckboxMenuItemPeer)p;
    return new TUICheckboxMenuItem(mi,this);
  }
  protected PopupMenuPeer createPopupMenu(PopupMenu target) {
    return new TUIPopupMenu(target,this);
  }

  // Helper functions for component peers

  Insets getInsets(TUIContainer c) {
    Insets insets = new Insets(1,1,1,1);
    Dimension s = scale(new Dimension(1,1));
    insets.left *= s.width;
    insets.right *= s.width;
    insets.top *= s.height;
    insets.bottom *= s.height;
    return insets;
  }
}
