package bmsi.tui;
import java.awt.*;
import java.awt.event.*;
import java.awt.peer.*;

class TUILabel extends TUIComponent implements LabelPeer {
  TUILabel(Label lab,TUIKit toolkit) { super(lab,toolkit); }
  protected void create(TUIContainer parent) {
    winID = toolkit.createRemotePeer(parent,NEWLABEL,this);
  }
  protected void initialize() {
    Label lab = (Label)target;
    String text = lab.getText();
    int a = lab.getAlignment();
    if (text != null)
      setText(text);
    if (a != 0)
      setAlignment(a);
    super.initialize();
  }
  public Dimension getMinimumSize() {
    Label lab = (Label)target;
    return toolkit.scale(new Dimension(lab.getText().length(),1));
  }
  public void setAlignment(int a) { toolkit.writeCmd(this,SETALIGNMENT,a); }
  public void setText(String s) { toolkit.writeCmd(this,SETTEXT,s); }
  public boolean isFocusTraversable() { return false; }
}
