package bmsi.tui;
import java.awt.*;
import java.awt.peer.TextAreaPeer;

class TUITextArea extends TUITextComponent implements TextAreaPeer {
  TUITextArea(TextArea t,TUIKit toolkit) { super(t,toolkit); }
  protected void create(TUIContainer parent) {
    winID = toolkit.createRemotePeer(parent,NEWTEXTAREA,this);
  }
  protected void initialize() {
    TextArea c = (TextArea)target;
    int v = c.getScrollbarVisibility();
    switch (v) {
    case c.SCROLLBARS_NONE: case c.SCROLLBARS_VERTICAL_ONLY:
      setColumns(c.getColumns());
      break;
    default:
      setColumns(0);
    }
    super.initialize();
  }
  public void insert(String s,int pos) { replaceRange(s,pos,pos); }
  public void replaceRange(String s,int start,int end) {
    toolkit.writeCmd(this,REPLACETEXT,s,start,end);
    selectEnd = end + s.length();
    selectBegin = selectEnd;
    if (txt != null)
      txt = txt.substring(0,start) + s + txt.substring(end);
  }
  public Dimension getPreferredSize(int rows,int cols) {
    // FIXME: room for scroll bars ?
    return toolkit.scale(new Dimension(cols,rows));	
  }
  public Dimension getMinimumSize(int rows,int cols) {
    Dimension dim = new Dimension(20,5);
    if (rows < dim.height)
      dim.height = rows;
    if (cols < dim.width)
      dim.width = cols;
    return toolkit.scale(dim);
  }

  /* jdk 1.0 compatibility */
  public final Dimension preferredSize(int rows,int cols) {
    return getPreferredSize(rows,cols);
  }
  public final Dimension minimumSize(int rows,int cols) {
    return getMinimumSize(rows,cols);
  }
  public final void insertText(String s,int pos) { insert(s,pos); }
  public final void replaceText(String s,int start,int end) {
    replaceRange(s,start,end);
  }
}
