package bmsi.tui;

import java.awt.*;
import java.applet.*;
import java.net.*;
import java.lang.reflect.Method;
import java.util.Enumeration;

/** A mini Applet viewer.  We support just enough features to run
  a couple of applets that we care about.  Having this in its own class
  makes extending it easy.
 */

class Viewer extends Frame implements AppletStub, AppletContext {
  private Label status = new Label();
  private RemoteToolkit toolkit;
  Viewer(String name,RemoteToolkit toolkit) {
    super(name);
    this.toolkit = toolkit;
  }
  // -- AppletStub methods
  public void appletResize(int w,int h) { setSize(new Dimension(w,h)); }
  public boolean isActive() { return true; }
  public AppletContext getAppletContext() { return this; }
  public String getParameter(String name) { return null; }
  public URL getCodeBase() {
    try {
      return new URL("file:/home/stuart/belljava.jar");
    }
    catch (Exception e) {
      System.err.println(e);
      return null;
    }
  }
  public URL getDocumentBase() { return null; }
  // --
  // -- AppletContext methods
  public AudioClip getAudioClip(URL url) { return null; }
  public Image getImage(URL url) { return null; }
  public Applet getApplet(String name) { return null; }
  public Enumeration getApplets() {
    return new Enumeration() {
      public boolean hasMoreElements() { return false; }
      public Object nextElement() { return null; }
    };
  }
  public void showDocument(URL url) {
    toolkit.showDocument(url);
  }
  public void showDocument(URL url, String target) {
    showDocument(url);
  }
  public void showStatus(String st) {
    status.setText(st);
  }
  // --
  static void runClass(final String cname,final RemoteToolkit toolkit) {
    new Thread() {
      public void run() {
	try {
	  URL url = new URL(cname);
	  sun.applet.AppletViewer.main(new String[] { url.toString() });
	}
	catch (MalformedURLException x) {
	  Class c = null;
	  try {
	    c = Class.forName(cname);
	    Object app = c.newInstance();
	    if (app instanceof Applet) {
	      // a mini applet-viewer
	      Applet a = (Applet)app;
	      Viewer f = new Viewer(cname,toolkit);
	      a.setStub(f);
	      a.init();
	      f.add("Center",a);
	      f.add("South",f.status);
	      f.pack();
	      f.show();
	      a.start();
	    }
	  }
	  catch (NoSuchMethodError e) {
	    try {
	      Method m = c.getMethod("main",new Class[] { String[].class });
	      m.invoke(null,new Object[] { new String[0] });
	    }
	    catch (Exception ex) {
	      ex.printStackTrace();
	    }
	  }
	  catch (Exception e) {
	    e.printStackTrace();
	  }
	}
      }
    }.start();
  }
}
